#include <windows.h>


HMODULE hLib = ::LoadLibraryW(L"WSQ_library");

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
    return TRUE;
}


#ifdef __cplusplus
extern "C" {
#endif



#ifdef __BORLANDC__
__declspec(dllexport) int __cdecl SaveBMPToFile(HBITMAP hbitmap, const char* name, int name_len, int type)
#else
__declspec(dllexport) int __cdecl _SaveBMPToFile(HBITMAP hbitmap, const char* name, int name_len, int type)
#endif
{
	if (!hLib) {
		MessageBoxA(0, "Error: Unable to load WSQ_library.dll", "Error", 0);
		return 0;
	}

	typedef void (*_SaveBMPToFile)(HBITMAP, const char*, int);
	_SaveBMPToFile SaveBMPToFile = (_SaveBMPToFile)::GetProcAddress(hLib, "_SaveBMPToFile");
	if (!SaveBMPToFile) {
		MessageBoxA(0, "Error: function SaveBMPToFile not found in WSQ_library.dll", "Error", 0);
		return 0;
	}

	SaveBMPToFile(hbitmap, name, type);

	return 1;
}

#ifdef __BORLANDC__
__declspec(dllexport) HBITMAP __cdecl CreateBMPFromFile(const char* fileName, int)
#else
__declspec(dllexport) HBITMAP __cdecl _CreateBMPFromFile(const char* fileName, int)
#endif
{
	if (!hLib) {
		MessageBoxA(0, "Error: Unable to load WSQ_library.dll", "Error", 0);
		return 0;
	}

	typedef HBITMAP (*_createBMPFromFile)(const char*);
	_createBMPFromFile CreateBMPFromFile = (_createBMPFromFile)::GetProcAddress(hLib, "_CreateBMPFromFile");
	if (!CreateBMPFromFile) {
		MessageBoxA(0, "Error: function CreateBMPFromFile not found in WSQ_library.dll", "Error", 0);
		return 0;
	}

	return CreateBMPFromFile(fileName);
}

#ifdef __BORLANDC__
__declspec(dllexport) void __cdecl RegisterWSQ()
#else
__declspec(dllexport) void __cdecl _RegisterWSQ()
#endif
{
	if (!hLib) {
		MessageBoxA(0, "Error: Unable to load WSQ_library.dll", "Error", 0);
		return;
	}
	typedef void (*_RegisterWSQ)();
	_RegisterWSQ RegisterWSQ = (_RegisterWSQ)::GetProcAddress(hLib, "_RegisterWSQ");
	if (!RegisterWSQ) {
		MessageBoxA(0, "Error: function RegisterWSQ not found in WSQ_library.dll", "Error", 0);
		return;
	}

	RegisterWSQ();
}

#ifdef __BORLANDC__
__declspec(dllexport) void __cdecl WriteWSQ_bitrate(double bitrate)
#else
__declspec(dllexport) void __cdecl _WriteWSQ_bitrate(double bitrate)
#endif
{
	if (!hLib) {
		MessageBoxA(0, "Error: Unable to load WSQ_library.dll", "Error", 0);
		return;
	}

	typedef void (*_WriteWSQ_bitrate)(double);
	_WriteWSQ_bitrate WriteWSQ_bitrate = (_WriteWSQ_bitrate)::GetProcAddress(hLib, "_WriteWSQ_bitrate");
	if (!WriteWSQ_bitrate) {
		MessageBoxA(0, "Error: function WriteWSQ_bitrate not found in WSQ_library.dll", "Error", 0);
		return;
	}

	WriteWSQ_bitrate(bitrate);
}


#ifdef __BORLANDC__
__declspec(dllexport) double __cdecl ReadWSQ_bitrate()
#else
__declspec(dllexport) double __cdecl _ReadWSQ_bitrate()
#endif
{
	if (!hLib) {
		MessageBoxA(0, "Error: Unable to load WSQ_library.dll", "Error", 0);
		return 0;
	}

	typedef double (*_ReadWSQ_bitrate)();
	_ReadWSQ_bitrate ReadWSQ_bitrate = (_ReadWSQ_bitrate)::GetProcAddress(hLib, "_ReadWSQ_bitrate");
	if (!ReadWSQ_bitrate) {
		MessageBoxA(0, "Error: function ReadWSQ_bitrate not found in WSQ_library.dll", "Error", 0);
		return 0;
	}

	return ReadWSQ_bitrate();
}

#ifdef __BORLANDC__
__declspec(dllexport) void __cdecl WriteWSQ_ppi(int ppi)
#else
__declspec(dllexport) void __cdecl _WriteWSQ_ppi(int ppi)
#endif
{
	if (!hLib) {
		MessageBoxA(0, "Error: Unable to load WSQ_library.dll", "Error", 0);
		return;
	}

	typedef void (*_WriteWSQ_ppi)(int);
	_WriteWSQ_ppi WriteWSQ_ppi = (_WriteWSQ_ppi)::GetProcAddress(hLib, "_WriteWSQ_ppi");
	if (!WriteWSQ_ppi) {
		MessageBoxA(0, "Error: function WriteWSQ_ppi not found in WSQ_library.dll", "Error", 0);
		return;
	}

	WriteWSQ_ppi(ppi);
}

#ifdef __BORLANDC__
__declspec(dllexport) int __cdecl ReadWSQ_ppi()
#else
__declspec(dllexport) int __cdecl _ReadWSQ_ppi()
#endif
{
	if (!hLib) {
		MessageBoxA(0, "Error: Unable to load WSQ_library.dll", "Error", 0);
		return 0;
	}

	typedef int (*_ReadWSQ_ppi)();
	_ReadWSQ_ppi ReadWSQ_ppi = (_ReadWSQ_ppi)::GetProcAddress(hLib, "_ReadWSQ_ppi");
	if (!ReadWSQ_ppi) {
		MessageBoxA(0, "Error: function ReadWSQ_ppi not found in WSQ_library.dll", "Error", 0);
		return 0;
	}

	return ReadWSQ_ppi();
}

#ifdef __BORLANDC__
__declspec(dllexport) void __cdecl WriteWSQ_comment(char *comment, int comment_length)
#else
__declspec(dllexport) void __cdecl _WriteWSQ_comment(char *comment, int comment_length)
#endif
{
	if (!hLib) {
		MessageBoxA(0, "Error: Unable to load WSQ_library.dll", "Error", 0);
		return;
	}

	typedef void (*_WriteWSQ_comment)(const char*);
	_WriteWSQ_comment WriteWSQ_comment = (_WriteWSQ_comment)::GetProcAddress(hLib, "_WriteWSQ_comment");
	if (!WriteWSQ_comment) {
		MessageBoxA(0, "Error: function WriteWSQ_comment not found in WSQ_library.dll", "Error", 0);
		return;
	}

	WriteWSQ_comment(comment);
}

#ifdef __BORLANDC__
__declspec(dllexport) char* __cdecl ReadWSQ_comment()
#else
__declspec(dllexport) char* __cdecl _ReadWSQ_comment()
#endif
{
	if (!hLib) {
		MessageBoxA(0, "Error: Unable to load WSQ_library.dll", "Error", 0);
		return 0;
	}

	typedef char* (*_ReadWSQ_comment)();
	_ReadWSQ_comment ReadWSQ_comment = (_ReadWSQ_comment)::GetProcAddress(hLib, "_ReadWSQ_comment");
	if (!ReadWSQ_comment) {
		MessageBoxA(0, "Error: function ReadWSQ_comment not found in WSQ_library.dll", "Error", 0);
		return 0;
	}

	return ReadWSQ_comment();
}

#ifdef __BORLANDC__
__declspec(dllexport) void __cdecl WriteTIFFcompression(int tiff_compression)
#else
__declspec(dllexport) void __cdecl _WriteTIFFcompression(int tiff_compression)
#endif
{
	if (!hLib) {
		MessageBoxA(0, "Error: Unable to load WSQ_library.dll", "Error", 0);
		return;
	}
	
	typedef void (*_WriteTIFFcompression)(int);
	_WriteTIFFcompression WriteTIFFcompression = (_WriteTIFFcompression)::GetProcAddress(hLib, "_WriteTIFFcompression");
	if (!WriteTIFFcompression) {
		MessageBoxA(0, "Error: function WriteTIFFcompression not found in WSQ_library.dll", "Error", 0);
		return;
	}

	WriteTIFFcompression(tiff_compression);
}

#ifdef __BORLANDC__
__declspec(dllexport) void __cdecl WriteTIFFpredictor(int tiff_predictor)
#else
__declspec(dllexport) void __cdecl _WriteTIFFpredictor(int tiff_predictor)
#endif
{
	if (!hLib) {
		MessageBoxA(0, "Error: Unable to load WSQ_library.dll", "Error", 0);
		return;
	}

	typedef void (*_WriteTIFFpredictor)(int);
	_WriteTIFFpredictor WriteTIFFpredictor = (_WriteTIFFpredictor)::GetProcAddress(hLib, "_WriteTIFFpredictor");
	if (!WriteTIFFpredictor) {
		MessageBoxA(0, "Error: function WriteTIFFpredictor not found in WSQ_library.dll", "Error", 0);
		return;
	}

	WriteTIFFpredictor(tiff_predictor);
}

#ifdef __BORLANDC__
__declspec(dllexport) void __cdecl SetShowFilePropertiesDialog(int file_properties_dialog)
#else
__declspec(dllexport) void __cdecl _SetShowFilePropertiesDialog(int file_properties_dialog)
#endif
{
	if (!hLib) {
		MessageBoxA(0, "Error: Unable to load WSQ_library.dll", "Error", 0);
		return;
	}

	typedef void (*_SetShowFilePropertiesDialog)(int);
	_SetShowFilePropertiesDialog SetShowFilePropertiesDialog = (_SetShowFilePropertiesDialog)::GetProcAddress(hLib, "_SetShowFilePropertiesDialog");
	if (!SetShowFilePropertiesDialog) {
		MessageBoxA(0, "Error: function SetShowFilePropertiesDialog not found in WSQ_library.dll", "Error", 0);
		return;
	}

	SetShowFilePropertiesDialog(file_properties_dialog);
}

#ifdef __BORLANDC__
__declspec(dllexport) void __cdecl ShowFileConverter()
#else
__declspec(dllexport) void __cdecl _ShowFileConverter()
#endif
{
	if (!hLib) {
		MessageBoxA(0, "Error: Unable to load WSQ_library.dll", "Error", 0);
		return;
	}

	typedef void (*_ShowFileConverter)();
	_ShowFileConverter ShowFileConverter = (_ShowFileConverter)::GetProcAddress(hLib, "_ShowFileConverter");
	if (!ShowFileConverter) {
		MessageBoxA(0, "Error: function ShowFileConverter not found in WSQ_library.dll", "Error", 0);
		return;
	}

	ShowFileConverter();
}


#ifdef __cplusplus
}
#endif


